package ui;

import workflow.ListerPersonnesWorkflow;

/**
 * Interface utilisateur : liste toutes les personnes
 * dont le nom commence par une lettre donne.
 * This file is free Software
 * (c) Serge Rosmorduc
 * @author rosmord
 *
 */
public class ListerPersonnesUI {

	SimpleIO io;
	ListerPersonnesWorkflow workflow;

	public ListerPersonnesUI(SimpleIO io, ListerPersonnesWorkflow workflow) {
		this.io= io;
		this.workflow= workflow;
	}

	public void fixerLettre() {
		String lettre;
		lettre= io.lireLigne("entrez le dbut du nom cherch : " );
		workflow.fixerLettre(lettre);
	}
	/**
	 * Method executer.
	 */
	public void executer() {
		fixerLettre();
		listerPersonnes();
	}

	/**
	 * Method listerPersonnes.
	 */
	private void listerPersonnes() {
		workflow.listerPersonnes();
		while (! workflow.estTerminee()) {
			// La stricte sparation des couches voudrait que
			// la classe personne ne ft pas visible ici.
			// Une mthode du type :
			// Personne p= workflow.getPersonne();
			// semble pratique et de bon got.
			// Cependant :
			//		A) en toute rigueur, cet objet ne devrait pas tre modifiable
			//		   c.--d. qu'en toute rigueur, il faudrait dfinir :
			//		   		une classe Personne
			//				une interface PersonneIF en lecture seule
			//				une classe proxy implmentant cette dernire interface.
			//		B) le comportement du programme est alors difficile  prdire.
			//			en effet, si l'on garde cet objet, rien ne garantit qu'il garde sa valeur
			//			ou qu'il est modifi (a dpend de l'implmentation du workflow).
			//			 noter que la solution vue en A permet de rsoudre le problme lgament,
			//			quoiqu'avec du travail (la classe proxy tant synchronise par dfinition avec
			//			le workflow.
			io.ecrire("id " + workflow.getIDPersonne()+" ");
			io.ecrire("nom " + workflow.getNom()+" ");
			io.ecrire("prenom " + workflow.getPrenom()+ "\n");
			workflow.next();
		}
	}
}
