package workflow;
/**
 * This file is free Software
 * (c) Serge Rosmorduc
 * @author rosmord
 *
 */
import persistence.*;
import modele.*;

public class AjoutPersonneWorkflow {

	Personne p;
	PersonneDAO persisteur;

	public AjoutPersonneWorkflow(PersonneDAO persisteur) {
		p= new Personne();
		this.persisteur= persisteur;
	}

	/**
	 * Method ajouterPersonne.
	 */
	public void ajouterPersonne() {
		// Fixer le numro de la personne
		// Peut ventuellement tre ralis automatiquement
		// par le persisteur ou le SQL.
		int id= persisteur.getMaxPersonneID();
		p.setIdPersonne(id+1);
		persisteur.create(p);
	}

	/**
	 * Method fixerNom.
	 * @param nom
	 */
	public void fixerNom(String nom) {
		p.setNom(nom);
	}

	/**
	 * Method fixerPrenom.
	 * @param prenom
	 */
	public void fixerPrenom(String prenom) {
		p.setPrenom(prenom);
	}

}
